web-dev-qa-db-ja.com

コマンドライン引数を任意の文字列で解析する方法

引用符で囲まれた任意のテキスト(スペースを含む)を含むオプションを持つスクリプトを作成しようとしていますが、これは検索と実装が難しいことがわかります。

基本的に、私が望む動作はdocker_build_image.sh -i "image" -v 2.0 --options "--build-arg ARG=value"です。これは、ビルドサーバーでのDockerイメージのバージョン管理を簡略化するヘルパースクリプトです。

--options値を正常に取得するのに最も近い場所にあると、getoptから「認識できないオプション '--build-arg ARG = value」というエラーが発生します。

完全なスクリプトは以下のとおりです

#!/usr/bin/env bash
set -o errexit -o noclobber -o nounset -o pipefail
params="$(getopt -o hi:v: -l help,image:,options,output,version: --name "$0" -- "$@")"
eval set -- "$params"

show_help() {
cat << EOF
Usage: ${0##*/} [-i IMAGE] [-v VERSION] [OPTIONS...]

Builds the docker image with the Dockerfile located in the current directory.

    -i, --image         Required. Set the name of the image.
    --options           Set the additional options to pass to the build command.
    --output            (Default: stdout) Set the output file.
    -v, --version       Required. Tag the image with the version.
    -h, --help          Display this help and exit.
EOF
}

while [[ $# -gt 0 ]]
do
    case $1 in
        -h|-\?|--help)
            show_help
            exit 0
            ;;
        -i|--image)
            if [ -n "$2" ]; then
                IMAGE=$2
                shift
            else
                echo -e "ERROR: '$1' requires an argument.\n" >&2
                exit 1
            fi
            ;;        
        -v|--version)            
            if [ -n "$2" ]; then
                VERSION=$2
                shift
            else
                echo -e "ERROR: '$1' requires an argument.\n" >&2
                exit 1
            fi
            ;;
        --options)
        echo -e "OPTIONS=$2\n"
            OPTIONS=$2
        ;;
        --output)            
            if [ -n "$2" ]; then
                BUILD_OUTPUT=$2
                shift
            else
                BUILD_OUTPUT=/dev/stderr
            fi
        ;;
        --)
            shift
            break
        ;;
        *)
            echo -e "Error: $0 invalid option '$1'\nTry '$0 --help' for more information.\n" >&2
            exit 1
        ;;
    esac
shift
done

echo "IMAGE: $IMAGE"
echo "VERSION: $VERSION"
echo ""

# Grab the SHA-1 from the docker build output
ID=$(docker build ${OPTIONS} -t ${IMAGE}  . | tee $BUILD_OUTPUT | tail -1 | sed 's/.*Successfully built \(.*\)$/\1/')

# Tag our image
docker tag ${ID} ${IMAGE}:${VERSION}
docker tag ${ID} ${IMAGE}:latest
3
Greg B

引数を取る他のもの(imageおよびversion)を処理するのと同じように処理します。つまり、必須の引数であることを示すコロンをgetoptに送信されるオプション文字列に追加し、$2から値を選択します。

あなたが得るエラーはgetoptoptionsが引数を取ることを知らされていないので--build-arg ARG=valueを長いオプションとして解釈しようとするためです(それはダブルダッシュ)。

$ cat opt.sh
#!/bin/bash
params="$(getopt -o hv: -l help,options:,version: --name "$0" -- "$@")"
eval set -- "$params"

while [[ $# -gt 0 ]] ; do
    case $1 in
        -h|-\?|--help)
            echo "help"
            ;;
        -v|--version)            
            if [ -n "$2" ]; then
                echo "version: <$2>"
                shift
            fi
            ;;
        --options)            
            if [ -n "$2" ]; then
                echo "options: <$2>"
                shift
            fi
            ;;
    esac
    shift
done

$ bash opt.sh --version 123 --options blah --options "foo bar"
version: <123>
options: <blah>
options: <foo bar>
5
ilkkachu